import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class OceanWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class OceanWorld extends World
{
    private int sharksDodged = 0;
    private int medals = 367; // 367 is 0 medals

    //objects
    Phelps player = new Phelps();
    HealthBar hbar = new HealthBar();
    MedalBar mbar = new MedalBar();
    Shark shark = new Shark();
    HealthBonus bonus = new HealthBonus();
    Ship ship = new Ship();
    OilSpill oil = new OilSpill();
    Bernard bernie = new Bernard();
    Burger burger = new Burger();
    Lose lose = new Lose();
    Won won = new Won();
    Messages zeromeds = new ZeroMedalsMessage();
    Messages onemed = new OneMedalMessage();
    Messages twomeds = new TwoMedalMessage();
    Messages threemeds = new ThreeMedalMessage();
    Messages fourmeds = new FourMedalMessage();
    Messages fivemeds = new FiveMedalMessage();
    Messages sixmeds = new SixMedalMessage();
    Messages sevenmeds = new SevenMedalMessage();
    Messages eightmeds = new EightMedalMessage();

    //medal count
    boolean gotOneMedal = false;
    boolean gotTwoMedals = false;
    boolean gotThreeMedals = false;
    boolean gotFourMedals = false;
    boolean gotFiveMedals = false;
    boolean gotSixMedals = false;
    boolean gotSevenMedals = false;
    boolean gotEightMedals = false;
    boolean gotNineMedals = false;

    
    public OceanWorld()
    {    
        // Create a new world with 50x50 cells with a cell size of 10x10 pixels.
        super(411, 400, 1);
        addObject(player, 205, 386); 
        addObject(hbar, 8, player.getHealth());
        addObject(mbar, 402, medals);
        addObject(zeromeds, 219, 197);

    }

// moves health bar according to player's health
    public void moveHealthBar(){
        hbar.setLocation(8, player.getHealth());
    }

// moves medal bar according to number of medals (how many sharks dodged)    
    public void moveMedalBar(){
        mbar.setLocation(402, medals);
    }

    public void act(){
        int rand = Greenfoot.getRandomNumber(20);
        addMedals();
        if(rand == 1){
            addObstacles();
        } if(player.getHealth() >= 390){
            addObject(lose, 203, 200);
            Greenfoot.stopSimulation();
        } else if (gotNineMedals){
            addObject(won, 206, 200);
            Greenfoot.stopSimulation();
        }
    }
    
    
    public void moreSharksDodged(){
        sharksDodged = sharksDodged + 1;        
    }

//adds medals according to how many sharks dodged:
//dodge 1 shark for 1st medal 
//dodge 2 more for 2nd and 3rd medals
//dodge 3 more for 4th, 5th, 6th, and 7th medals 
//dodge and 4 more for 8th and 9th medal
    public void addMedals(){
        if (sharksDodged == 0){
            medals = medals;
        }else if(sharksDodged == 1 && gotOneMedal == false){
            removeObject(zeromeds);
            medals = medals - 20;
            moveMedalBar();
            addObject(onemed, 198, 337);
            gotOneMedal = true;
        } else if(sharksDodged == 3 && gotTwoMedals == false){
            removeObject(onemed);
            medals = medals - 40;
            moveMedalBar();
            addObject(twomeds, 207, 333);
            gotTwoMedals = true;
        } else if(sharksDodged == 5 && gotThreeMedals == false){
            removeObject(twomeds);
            medals = medals - 45;
            moveMedalBar();
            addObject(threemeds, 207, 226);
            gotThreeMedals = true;
        } else if(sharksDodged == 8 && gotFourMedals == false){
            removeObject(threemeds);
            medals = medals - 45;
            moveMedalBar();
            addObject(fourmeds, 207, 235);
            gotFourMedals = true;
        } else if(sharksDodged == 11 && gotFiveMedals == false){
            removeObject(fourmeds);
            medals = medals - 40;
            moveMedalBar();
            addObject(fivemeds, 207, 235);
            gotFiveMedals = true;
        } else if(sharksDodged == 14 && gotSixMedals == false){
            removeObject(fivemeds);
            medals = medals - 40;
            moveMedalBar();
            addObject(sixmeds, 215, 226);
            gotSixMedals = true;
        } else if(sharksDodged == 17 && gotSevenMedals == false){
            removeObject(sixmeds);
            medals = medals - 40;
            moveMedalBar();
            addObject(sevenmeds, 346, 199);
            gotSevenMedals = true;
        } else if(sharksDodged == 21 && gotEightMedals == false){
            removeObject(sevenmeds);            
            medals = medals - 45;
            moveMedalBar();
            addObject(eightmeds, 216, 205);            
            gotEightMedals = true;
        } else if(sharksDodged == 25 && gotNineMedals == false){
            removeObject(eightmeds);            
            medals = medals - 40;
            moveMedalBar();
            gotNineMedals = true;
        }
    }
    
    
//adds obstacles
    public void addObstacles(){
        int r = Greenfoot.getRandomNumber(100);
        int x = Greenfoot.getRandomNumber(305) + 60;
        if(r < 10){
             addObject(bernie, x, 0);
            } if(r >= 10 && r < 20){
             addObject(burger, x, 0);
            } if(r >= 20 && r < 30){
             addObject(bonus, x, 0);
            } if(r >= 30 && r < 85){
                addObject(shark, x, 0);
            } if(r >= 85 && r < 95){
                addObject(oil, x, 0);
            } if (r >= 95){
                addObject(ship, x, 0);
                }
        }       

                  
}